import { EditorView, ViewUpdate, BlockInfo } from "../../view";
import { Range, RangeValue, RangeSet } from "../../rangeset";
import { ChangeSet } from "../../state";
export declare abstract class GutterMarker extends RangeValue {
    compare(other: GutterMarker): boolean;
    abstract eq(other: GutterMarker): boolean;
    map(mapping: ChangeSet, pos: number): Range<GutterMarker> | null;
    toDOM(): Node | null;
    at(pos: number): Range<this>;
    elementClass: string;
}
export interface GutterConfig {
    class: string;
    fixed?: boolean;
    renderEmptyElements?: boolean;
    elementClass?: string;
    initialMarkers?: (view: EditorView) => RangeSet<GutterMarker>;
    updateMarkers?: (markers: RangeSet<GutterMarker>, update: ViewUpdate) => RangeSet<GutterMarker>;
    lineMarker?: (view: EditorView, line: BlockInfo, markers: ReadonlyArray<GutterMarker>) => GutterMarker | null;
    initialSpacer?: null | ((view: EditorView) => GutterMarker);
    updateSpacer?: null | ((spacer: GutterMarker, update: ViewUpdate) => GutterMarker);
}
export declare function gutter<T>(config: GutterConfig): import("../../extension/dist/extension").Extension[];
export interface LineNumberConfig {
    fixed?: boolean;
    formatNumber?: (lineNo: number) => string;
}
export declare const lineNumberMarkers: import("../../extension/dist/extension").SlotType<LineNumberMarkerUpdate>;
export declare type LineNumberMarkerUpdate = {
    add?: Range<GutterMarker>[];
    filter?: (from: number, to: number, marker: GutterMarker) => boolean;
};
export declare const lineNumbers: (spec?: LineNumberConfig | undefined) => import("../../extension/dist/extension").Extension;
