import { Text } from "../../text";
import { Slot, SlotType, Extension, Configuration } from "../../extension";
import { EditorState } from "./state";
import { EditorSelection, SelectionRange } from "./selection";
import { Change, ChangeSet } from "./change";
export declare class Transaction {
    readonly startState: EditorState;
    changes: ChangeSet;
    docs: Text[];
    selection: EditorSelection;
    private metadata;
    private flags;
    configuration: Configuration<EditorState>;
    private state;
    constructor(startState: EditorState, time?: number);
    readonly doc: Text;
    addMeta(...metadata: Slot[]): Transaction;
    getMeta<T>(type: SlotType<T>): T | undefined;
    change(change: Change, mirror?: number): Transaction;
    readonly docChanged: boolean;
    replace(from: number, to: number, text: string | ReadonlyArray<string>): Transaction;
    replaceSelection(text: string | ReadonlyArray<string>): Transaction;
    forEachRange(f: (range: SelectionRange, tr: Transaction) => SelectionRange): Transaction;
    setSelection(selection: EditorSelection): Transaction;
    readonly selectionSet: boolean;
    scrollIntoView(): Transaction;
    readonly scrolledIntoView: boolean;
    replaceExtensions(replace: readonly Extension[]): this;
    reconfigure(extensions: readonly Extension[]): this;
    readonly reconfigured: boolean;
    private ensureOpen;
    apply(): EditorState;
    invertedChanges(): ChangeSet<Change>;
    static time: SlotType<number>;
    static preserveGoalColumn: SlotType<boolean>;
    static userEvent: SlotType<string>;
    static addToHistory: SlotType<boolean>;
}
